//---------------------------------------------------------------------------
//
// Copyright (C) 2002 Mika Sderholm.
// All Rights Reserved.
//
//---------------------------------------------------------------------------
/*
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All materials mentioning features or use of this software
   must display the following acknowledgement:
      This product includes software developed by Mika Sderholm.
4. Any commercial use is prohibited.

THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL MIKA SDERHOLM BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
//---------------------------------------------------------------------------
//  For more information contact email: mika.soderholm@luukku.com
//---------------------------------------------------------------------------
#ifndef AudioMeterH
#define AudioMeterH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <mmsystem.h>
#include "TimeThread.h"
#include "CorrelationThread.h"
#include "StereoThread.h"
#include "PeakThread.h"
//---------------------------------------------------------------------------
class TAMForm : public TForm
{
__published:	// IDE-managed Components
        TPaintBox *Correlation;
        TPaintBox *TimeSerie;
        TPaintBox *Stereo;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TPaintBox *Peak;
        TLabel *Label4;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label5;
        TLabel *Label12;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall CorrelationPaint(TObject *Sender);
private:	// User declarations


        TimeThread*        timethread;
        CorrelationThread* correlationthread;
        StereoThread*      stereothread;
        PeakThread*        peakthread;

        HWAVEIN   hWaveIn;
        WAVEHDR*  WaveHeaders;
        WAVEFORMATEX  waveFormat;

        int       buff;
        int       buffers;
        int       buffer_size;
        int       WaveBufSize;
        WAVEHDR*  SendHeader;
        bool      isStart;

public:		// User declarations
        __fastcall TAMForm(TComponent* Owner);
        void __fastcall ProcessInput();
};
//---------------------------------------------------------------------------
extern PACKAGE TAMForm *AMForm;
//---------------------------------------------------------------------------
#endif
