//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "PeakThread.h"
#include <math>
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall PeakThread::PeakThread( bool CreateSuspended, int in )
                      :TThread(CreateSuspended)
{
   count=in;
}

__fastcall PeakThread::~PeakThread()
{
}

void PeakThread::Process( TPaintBox* in, short* idata )
{
   data=idata;
   view=in;
   Resume();
}

//---------------------------------------------------------------------------
void __fastcall PeakThread::Execute()
{
   while ( !Terminated )
   {
      FillBuffer();
   }
}

void __fastcall PeakThread::FillBuffer()
{
   double peakleft = 0;
   double peakright = 0;
   for( int i = 0; i<count; i++)
   {
       double left = fabs(static_cast<double>(*data++));
       double right = fabs(static_cast<double>(*data++));
       peakleft = left>peakleft?left:peakleft;
       peakright = right>peakright?right:peakright;
   }

   double coef = view->ClientWidth/32768.0;
   TRect lr;
   lr.Left=1;
   lr.Right=coef*peakleft;
   lr.Top=2;
   lr.Bottom=18;

   TRect rr;
   rr.Left=1;
   rr.Right=coef*peakright;
   rr.Top=22;
   rr.Bottom=38;

   view->Canvas->Lock();
   view->Canvas->Brush->Color = clBlack;
   view->Canvas->Pen->Color = clWhite;
   view->Canvas->Rectangle( 0, 0, view->ClientWidth, view->ClientHeight );
   view->Canvas->Brush->Color = clAqua;
   view->Canvas->FillRect( lr );
   view->Canvas->FillRect( rr );
   view->Canvas->Unlock();
   Suspend();
}
//---------------------------------------------------------------------------
